using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;
using Phoenix.Xna.Framework;

namespace Phoenix.Xna.Framework.ContentPipeline.Animation
{
    [ContentTypeWriter]
    internal class AnimationClipWriter : ContentTypeWriter<AnimationClipContent>
    {
        protected override void Write(ContentWriter output, AnimationClipContent value)
        {
            value.Write(output);
        }

        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return typeof(AnimationClipReader).AssemblyQualifiedName;
        }
    }
}