﻿using Phoenix.Xna.Framework.Graphics;
using Phoenix.Xna.Framework.Serialization;

namespace Phoenix.Xna.Framework.ContentPipeline.EffectMaps
{
    /// <summary>
    /// Holds the EffectMap to be written through the content pipeline.
    /// </summary>
    public class EffectMapContent
    {
        /// <summary>
        /// Gets or sets the EffectMap to be written.
        /// </summary>
        public EffectMap EffectMap { get; set; }

        /// <summary>
        /// Serializes the EffectMap.
        /// </summary>
        /// <returns>The serialized EffectMap as a string.</returns>
        public string Serialize()
        {
            Serializer s = new Serializer();
            return s.Serialize(EffectMap);
        }
    }
}
