﻿namespace Phoenix.Xna.Framework.ContentPipeline
{
    public interface IContentService : IService, IDisposableEx
    {
        string RootDirectory { get; set; }

        T Load<T>(string assetName);
        void Unload();
        void Unload(string assetName);
        void Release(string assetName);
        T Reload<T>(string assetName);
        bool IsLoaded(string assetName);
        int ReferenceCount(string assetName);
    }
}
