﻿using System.Reflection;
using System.Xml.Linq;

namespace Phoenix.Xna.Framework.Serialization.Markup
{
    /// <summary>
    /// A XAML namespace definition for a CLR object.
    /// </summary>
    internal class NamespaceDefinition
    {
        /// <summary>
        /// Gets or sets the assembly.
        /// </summary>
        public Assembly Assembly { get; set; }

        /// <summary>
        /// Gets or sets XAML the namespace.
        /// </summary>
        public XNamespace XmlNamespace { get; set; }

        /// <summary>
        /// Gets or sets the CLR namespace.
        /// </summary>
        public string ClrNamespace { get; set; }
    }
}
