﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Phoenix.Xna.Framework.Serialization;
using Phoenix.Xna.Framework.Graphics;
using Phoenix.Xna.Framework;

namespace SerializationTest
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();
            SerializeEffectMap();
        }

        private void SerializeEffectMap()
        {
            EffectMap m = new EffectMap()
            {
                ID = "Test ID",
                Tag = "Test Tag"
            };

            for (int i = 0; i < 5; i++)
            {
                ValueBinding v = new ValueBinding()
                {
                    ID = "Binding ID",
                    MetaData = "Binding Meta-Data",
                    Value = 42
                };
                m.Variables.Add(v);
            }

            Serializer s = new Serializer();
            string serializedData = s.Serialize(m);
        }
    }
}
