﻿using Microsoft.Xna.Framework;
using Phoenix.Xna.Framework.FrameworkExtensions;

namespace Phoenix.Xna.Framework.Components.Sky
{
    public class SkyDomeShaderState
    {
        private Vector3 _sunlightDirection;

        public float Theta { get; set; }
        public float Phi { get; set; }
        public Vector3 SunlightDirection
        {
            get { return _sunlightDirection; }
            set
            {
                _sunlightDirection = value;
                _sunlightDirection.Normalize();
            }
        }
        public Vector3 SunlightColor { get; set; }
    }
}
