﻿using System;

namespace Phoenix.Xna.Framework.Components.Terrain
{
    [Flags]
    public enum NodeContent : ushort
    {
        None = 0,
        NorthWestVertex = 1,
        NorthEastVertex = 2,
        SouthEastVertex = 4,
        SouthWestVertex = 8,
        CenterVertex = 16,
        WestVertex = 32,
        NorthVertex = 64,
        EastVertex = 128,
        SouthVertex = 256,
        NorthWestChild = 512,
        NorthEastChild = 1024,
        SouthWestChild = 2048,
        SouthEastChild = 4096
    }
}
