using System;
using Phoenix.Xna.Framework.Graphics.Animation;

namespace Phoenix.Xna.Framework.ContentPipeline.Animation
{
    public class AnimationKeyframeContent : IComparable<AnimationKeyframeContent>
    {
        public TimeSpan Time { get; private set; }
        public Pose Pose { get; private set; }

        internal AnimationKeyframeContent(TimeSpan time, Pose pose)
        {
            Time = time;
            Pose = pose;
        }

        public int CompareTo(AnimationKeyframeContent other)
        {
            return Time.CompareTo(other.Time);
        }
    }
}